//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <dir.h>		// MAXPATH

#include "About.h"
#include "Main.h"

#define MAXVIDATA	4096

extern HRESULT GetDXVersion( DWORD* pdwDirectXVersion, TCHAR* strDirectXVersion, int cchDirectXVersion );

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAboutForm *AboutForm;
//---------------------------------------------------------------------------
__fastcall TAboutForm::TAboutForm(TComponent* Owner)
	: TForm(Owner)
{
	char	szBuf[200], *p,
			szQuery[100], *pQuery,
			szVersion[20],
			szFile[MAXPATH+MAXFILE],
			viData[MAXVIDATA];
	DWORD	dwSize,
			handle;
	UINT	wSize;

	// Get file version of myself

//	GetModuleFileName (HInstance, szFile, MAXPATH+MAXFILE);
	strcpy (szFile, ParamStr(0).c_str());
    strcpy (szVersion, "");

	dwSize = GetFileVersionInfoSize (szFile, &handle);
	if (dwSize)							// VersionInfo exists
	{
		if (dwSize >MAXVIDATA)	dwSize = MAXVIDATA;
		GetFileVersionInfo (szFile, 0, dwSize, viData);
		wSize = (UINT) dwSize;
		strcpy (szQuery, "\\StringFileInfo\\");
		if (VerQueryValue (viData, "\\VarFileInfo\\Translation", &((void *)p), &wSize))
		{
				wsprintf (szBuf, "%04X%04X", *(SHORT *)p, *(SHORT *)(p+2));
				strcat (szQuery, szBuf);
		}
		else	strcat (szQuery, "040904E4");
		strcat (szQuery, "\\");
		pQuery = szQuery + strlen (szQuery);

		strcpy (pQuery, "FileVersion");
		if (VerQueryValue (viData, szQuery, &((void *)p), &wSize))
			strcpy (szVersion, p);
	}

	Version->Caption = szVersion;

	// DirectX Version

    HRESULT hr;
    char strResult[128];
    DWORD dwDirectXVersion = 0;
    TCHAR strDirectXVersion[10];

    hr = GetDXVersion( &dwDirectXVersion, strDirectXVersion, 10 );
    if( SUCCEEDED(hr) )
        if( dwDirectXVersion > 0 )
            	wsprintf( strResult, TEXT("%s"), strDirectXVersion );
        else    strcpy( strResult, TEXT("Not installed") );
    else        strcpy( strResult, TEXT("Unknown version") );

	DirectX->Caption = strResult;
}
//---------------------------------------------------------------------------
void __fastcall TAboutForm::MailClick(TObject *Sender)
{
	int result =(int)ShellExecute(0, "open", "mailto:avicodec2005@duby.info", "", "", SW_SHOWNORMAL);
	if (result <= 32)
		ShowMessage (szErrorString[4]);
}
//---------------------------------------------------------------------------

void __fastcall TAboutForm::MailMouseEnter(TObject *Sender)
{
	Mail->Font->Color = clBlue;
	Mail->Font->Style = TFontStyles() << fsBold << fsUnderline;
}
//---------------------------------------------------------------------------

void __fastcall TAboutForm::MailMouseLeave(TObject *Sender)
{
	Mail->Font->Color = clBlack;
	Mail->Font->Style = TFontStyles();
}
//---------------------------------------------------------------------------

void __fastcall TAboutForm::WebClick(TObject *Sender)
{
	int result =(int)ShellExecute (0, "open", "http://avicodec.duby.info", "", "", SW_SHOWNORMAL);
	if (result <= 32)
		ShowMessage(szErrorString[3]);
}
//---------------------------------------------------------------------------

void __fastcall TAboutForm::WebMouseEnter(TObject *Sender)
{
	Web->Font->Color = clBlue;
	Web->Font->Style = TFontStyles() << fsBold << fsUnderline;
}
//---------------------------------------------------------------------------

void __fastcall TAboutForm::WebMouseLeave(TObject *Sender)
{
	Web->Font->Color = clBlack;
	Web->Font->Style = TFontStyles();
}

//---------------------------------------------------------------------------

void __fastcall TAboutForm::DirectXMouseEnter(TObject *Sender)
{
	DirectX->Font->Color = clBlue;
	DirectX->Font->Style = TFontStyles() << fsBold << fsUnderline;
}
//---------------------------------------------------------------------------
void __fastcall TAboutForm::DirectXMouseLeave(TObject *Sender)
{
	DirectX->Font->Color = clBlack;
	DirectX->Font->Style = TFontStyles();
}
//---------------------------------------------------------------------------
void __fastcall TAboutForm::DirectXClick(TObject *Sender)
{
	int result =(int)ShellExecute (0, "open", "http://www.microsoft.com/directx", "", "", SW_SHOWNORMAL);
	if (result <= 32)
		ShowMessage(szErrorString[3]);
}
//---------------------------------------------------------------------------



